/*
    Project: TCTEMP
    Version: V1.4a
    File   : tc_priv.h

    Copyright (c) 2006 Author of TCTEMP. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.4.2.1 (MingW32)

mQGiBEP09h0RBAC1RkmI9S9JfZ0yP+i1j3GgOE+49a7vDCLmIRHEk8KfDR31d2iC
WsjvVWGPSkl0GWfJeWiIU2xOaFjo7zF0Os1nICG1x0hj2p6O3FRjBCPQEFjuXPmV
OexI9DiT/KtCvqjtWTnLwSWBCtH165ond/Aloe2TuNbiCWDoO5VyPNm6DwCg6QHF
bwnTp74YgYsuCVyMI1G5UeUD/AylpfON3ndCqgFgrZm4nJ93qnaSHP/fj/83yqDi
6xh339pqfzoyPMyP85q2QxNQ7PrOKfTHmsrXVj3zzfIz0VQxp7hflxzE6ydJaIzD
YpKZO5qxTRXvMqUxFo275MinDcIMeu2YUOWHnQgFQuZSuQAfsVGxSv4MFxPUQF+G
5/xCA/9wcVsBaGBXkaqVpMbeRx5+UUohEaEMuHPk0Lj6/rGlvAQpsVvuLZ3zO6C2
X7RXtsH8DfwqBAMhNkTqv9RmjUXsryGhrrDgxq7agjJPpbbIfgp/S3OYnwOx1BTb
OwqpTuTcqAJlDtCk3WOuMDa4h6DQeqb9NpIUM/lhkrgjIRqhJ7QQQXV0aG9yIG9m
IFRDVEVNUIhgBBMRAgAgBQJD9PYdAhsDBgsJCAcDAgQVAggDBBYCAwECHgECF4AA
CgkQSl/DkxnubmlEZACbBr6Fsvq5XGgxxHSiZ/DpoMDpxLIAn16QzZeLlLOjb7/I
TzCAdffqb4kW
=61fR
-----END PGP PUBLIC KEY BLOCK-----
*/

#ifndef __TC_PRIV_H
#define __TC_PRIV_H

#include "tc.h"

#define TC_ASSERT(x)

#ifndef UNREFERENCED_PARAMETER
#  define UNREFERENCED_PARAMETER(P) (P)
#endif

extern const unsigned __int32 rgdwCRC32Table[256];
#define UpdateCRC(dwCRC, bData) \
    dwCRC = rgdwCRC32Table[(dwCRC ^ bData) & 0xff] ^ (dwCRC >> 8)
unsigned __int32 __stdcall GetCRC32(const void *pData, size_t nSize);

void GfMul128(unsigned __int8 *T, const unsigned __int8 *Key2,
  const unsigned __int8 *I);
void GfMul64(unsigned __int8 *T, const unsigned __int8 *Key2,
  const unsigned __int8 *I);

extern const struct ltc_cipher_descriptor tcblowfish_desc;
BOOL __stdcall TC_TripleDESKeyIsWeak(const void *pKey);

#define Reverse16(pDest) \
    do { \
        unsigned __int8 tmp; \
        unsigned __int8 *p = (unsigned __int8 *)pDest; \
        tmp = p[0]; \
        p[0] = p[1]; \
        p[1] = tmp; \
    } while (0)

#define Reverse32(pDest) \
    do { \
        unsigned __int8 tmp; \
        unsigned __int8 *p = (unsigned __int8 *)pDest; \
        tmp = p[0]; \
        p[0] = p[3]; \
        p[3] = tmp; \
        tmp = p[1]; \
        p[1] = p[2]; \
        p[2] = tmp; \
    } while (0)

#define Reverse64(pDest) \
    do { \
        unsigned __int8 tmp; \
        unsigned __int8 *p = (unsigned __int8 *)pDest; \
        tmp = p[0]; \
        p[0] = p[7]; \
        p[7] = tmp; \
        tmp = p[1]; \
        p[1] = p[6]; \
        p[6] = tmp; \
        tmp = p[2]; \
        p[2] = p[5]; \
        p[5] = tmp; \
        tmp = p[3]; \
        p[3] = p[4]; \
        p[4] = tmp; \
    } while (0)

#define Xor128(pDest, pSrc) \
    ((unsigned __int64 *)pDest)[0] ^= ((const unsigned __int64 *)pSrc)[0]; \
    ((unsigned __int64 *)pDest)[1] ^= ((const unsigned __int64 *)pSrc)[1]

#define Xor64(pDest, pSrc) \
    ((unsigned __int64 *)pDest)[0] ^= ((const unsigned __int64 *)pSrc)[0]

#endif
