/*
    Project: TCTEMP
    Version: V1.4a
    File   : na_rdtsc.c

    Copyright (c) 2006 Author of TCTEMP. All rights reserved.

    Covered by TrueCrypt License 2.1 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the following public key
    must be retained in full.

-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: GnuPG v1.4.2.1 (MingW32)

mQGiBEP09h0RBAC1RkmI9S9JfZ0yP+i1j3GgOE+49a7vDCLmIRHEk8KfDR31d2iC
WsjvVWGPSkl0GWfJeWiIU2xOaFjo7zF0Os1nICG1x0hj2p6O3FRjBCPQEFjuXPmV
OexI9DiT/KtCvqjtWTnLwSWBCtH165ond/Aloe2TuNbiCWDoO5VyPNm6DwCg6QHF
bwnTp74YgYsuCVyMI1G5UeUD/AylpfON3ndCqgFgrZm4nJ93qnaSHP/fj/83yqDi
6xh339pqfzoyPMyP85q2QxNQ7PrOKfTHmsrXVj3zzfIz0VQxp7hflxzE6ydJaIzD
YpKZO5qxTRXvMqUxFo275MinDcIMeu2YUOWHnQgFQuZSuQAfsVGxSv4MFxPUQF+G
5/xCA/9wcVsBaGBXkaqVpMbeRx5+UUohEaEMuHPk0Lj6/rGlvAQpsVvuLZ3zO6C2
X7RXtsH8DfwqBAMhNkTqv9RmjUXsryGhrrDgxq7agjJPpbbIfgp/S3OYnwOx1BTb
OwqpTuTcqAJlDtCk3WOuMDa4h6DQeqb9NpIUM/lhkrgjIRqhJ7QQQXV0aG9yIG9m
IFRDVEVNUIhgBBMRAgAgBQJD9PYdAhsDBgsJCAcDAgQVAggDBBYCAwECHgECF4AA
CgkQSl/DkxnubmlEZACbBr6Fsvq5XGgxxHSiZ/DpoMDpxLIAn16QzZeLlLOjb7/I
TzCAdffqb4kW
=61fR
-----END PGP PUBLIC KEY BLOCK-----
*/

#include "na.h"

#ifndef _WIN64

unsigned __int64 rdtsc(void)
{
    ULARGE_INTEGER uli;

    __try {
        __asm {
            xor     eax, eax
            cpuid
            rdtsc
            mov     uli.LowPart, eax
            mov     uli.HighPart, edx
        }
    } __except(EXCEPTION_EXECUTE_HANDLER) {
        uli.QuadPart = 0;
    }

    return uli.QuadPart;
}

#else

#pragma intrinsic(__cpuid)
extern void __cpuid(int rgiCPUInfo[4], int iInfoType);

#pragma intrinsic(__rdtsc)
extern unsigned __int64 __rdtsc(void);

unsigned __int64 rdtsc(void)
{
    int              rgiCPUInfo[4];
    unsigned __int64 ull;

    __try {
        __cpuid(rgiCPUInfo, 0);
        ull = __rdtsc();
    } __except(EXCEPTION_EXECUTE_HANDLER) {
        ull = 0;
    }

    return ull;
}

#endif